'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = callAction;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _isFunction = require('./isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _types = require('./types');

function callAction(_ref) {
  var responder = _ref.responder;
  var type = _ref.type;
  var initialState = _ref.initialState;
  var actionSetID = _ref.actionSetID;
  var actionID = _ref.actionID;
  var payload = _ref.payload;
  var notFoundValue = _ref.notFoundValue;
  var props = _ref.props;
  var sourceResponder = _ref.sourceResponder;

  var responderFunction = findActionResponder({ responder: responder, type: type, actionSetID: actionSetID, actionID: actionID, notFoundValue: notFoundValue });
  if (responderFunction !== notFoundValue) {
    return responderFunction(initialState, payload, { props: props, sourceResponder: sourceResponder });
  } else {
    return notFoundValue;
  }
}

function findActionResponder(_ref2) {
  var responder = _ref2.responder;
  var type = _ref2.type;
  var actionSetID = _ref2.actionSetID;
  var actionID = _ref2.actionID;
  var notFoundValue = _ref2.notFoundValue;

  if (responder[actionSetID]) {
    // Has forwarding function for entire type
    if ((0, _isFunction2['default'])(responder[actionSetID])) {
      return function (initialState, payload, _ref3) {
        var props = _ref3.props;

        function forwardTo(_ref4) {
          var responder = _ref4.responder;
          var initialState = _ref4.initialState;
          var _ref4$props = _ref4.props;
          var props = _ref4$props === undefined ? {} : _ref4$props;
          var sourceResponder = _ref4.sourceResponder;

          var responseNotFoundValue = undefined;
          if (type === _types.ACTION_TYPE) {
            responseNotFoundValue = initialState;
          }

          return callAction({
            notFoundValue: responseNotFoundValue,
            responder: responder, type: type, initialState: initialState, actionSetID: actionSetID, actionID: actionID, payload: payload,
            props: props, sourceResponder: sourceResponder
          });
        }

        var result = responder[actionSetID](initialState, {
          isAction: type === _types.ACTION_TYPE,
          isIntrospection: type === _types.INTROSPECTION_TYPE,
          type: type, actionID: actionID, payload: payload, props: props, forwardTo: forwardTo
        });
        if (typeof result === 'undefined') {
          return notFoundValue;
        } else {
          return result;
        }
      };
    } else {
      var typeResponder = undefined;
      // Actions are direct children
      if (type === _types.ACTION_TYPE) {
        typeResponder = responder[actionSetID];
      }
      // Others are grouped, such as introspection
      else if (responder[actionSetID][type]) {
          typeResponder = responder[actionSetID][type];
        } else {
          return notFoundValue;
        }

      if (typeResponder[actionID]) {
        return typeResponder[actionID];
      }
    }
  }

  return notFoundValue;
}
module.exports = exports['default'];