'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.createRootReducer = createRootReducer;
exports.connectActionSetsToStore = connectActionSetsToStore;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _createResourcesFromReducers2 = require('./createResourcesFromReducers');

var _createResourcesFromReducers3 = _interopRequireDefault(_createResourcesFromReducers2);

var _dispatch = require('./dispatch');

var _dispatch2 = _interopRequireDefault(_dispatch);

var _getConsensus = require('./getConsensus');

var _getConsensus2 = _interopRequireDefault(_getConsensus);

var _connectActionSets = require('./connectActionSets');

var _connectActionSets2 = _interopRequireDefault(_connectActionSets);

var _types = require('./types');

function createRootReducer(_ref) {
  var reducers = _ref.reducers;
  var idToProps = _ref.idToProps;

  var _createResourcesFromReducers = (0, _createResourcesFromReducers3['default'])({ reducers: reducers, idToProps: idToProps });

  var resources = _createResourcesFromReducers.resources;
  var states = _createResourcesFromReducers.states;

  var initialState = Object.assign(states, {
    _resources: resources
  });

  return function (state, action) {
    if (state === undefined) state = initialState;

    if (action.type === _types.FLAMBEAU_ACTION_TYPE && action.actionSetID && action.actionID && action.payload) {
      var changedStates = (0, _dispatch2['default'])({ resources: resources, states: state })(action);

      return Object.assign({}, state, changedStates);
    }

    return state;
  };
}

function connectActionSetsToStore(_ref2) {
  var actionSets = _ref2.actionSets;
  var _ref2$store = _ref2.store;
  var dispatch = _ref2$store.dispatch;
  var getState = _ref2$store.getState;

  return (0, _connectActionSets2['default'])({
    actionSets: actionSets,
    dispatch: dispatch,
    getConsensusForActionSet: function getConsensusForActionSet(actionSetID) {
      return (0, _getConsensus2['default'])({
        resources: getState()._resources,
        getStates: getState
      })(actionSetID);
    }
  });
}